



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL常见备份方案</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL常见备份方案</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 07:23:12 </span>
						</div>
										<div class="post-content">
											
		<p>MySQL常见备份方案有以下三种：</p>
<p>mysqldump + binlog</p>
<p>lvm + binlog</p>
<p>xtrabackup</p>
<p>本例为方便演示，数据库里面数据为空。下面开始动手</p>
<div>
<pre class="prettyprint linenums">mkdir /opt/backup                                #创建备份目录<br />
mkdir -p /data//{data,binlog}<br />
cd /usr/local/mysql/<br />
scripts/mysql_install_db --user=mysql --datadir=/data//data/ --basedir=/usr/local/mysql/<br />
chown mysql.mysql -R /data//<br />
cp support-files/my-small.cnf /data//my.cnf   #提供配置文件

vim /data//my.cnf                             #编辑配置文件</pre>
<pre class="prettyprint linenums">[client]<br />
#password&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;your_password<br />
port&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;3309<br />
socket&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;/tmp/mysql.sock4<br />
#&nbsp;The&nbsp;MySQL&nbsp;server<br />
[mysqld]<br />
port&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;3309<br />
socket&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;/tmp/mysql.sock4<br />
skip-external-locking<br />
key_buffer_size&nbsp;=&nbsp;16K<br />
max_allowed_packet&nbsp;=&nbsp;1M<br />
table_open_cache&nbsp;=&nbsp;4<br />
sort_buffer_size&nbsp;=&nbsp;64K<br />
read_buffer_size&nbsp;=&nbsp;256K<br />
read_rnd_buffer_size&nbsp;=&nbsp;256K<br />
net_buffer_length&nbsp;=&nbsp;2K<br />
thread_stack&nbsp;=&nbsp;128K<br />
datadir&nbsp;=&nbsp;/data/3309/data<br />
server-id&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;3309<br />
log-bin=/data/3309/binlog/mysql-bin&nbsp;&nbsp;&nbsp;#二进制日志位置<br />
binlog_format=mixed&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#二进制日志格式<br />
log-error&nbsp;=&nbsp;/data/3309/mysql-err&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#错误日志位置&nbsp;<br />
innodb_file_per_table&nbsp;=&nbsp;1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#为每一个新数据表创建一个表空间文件<br />
sync_binlog&nbsp;=&nbsp;1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#写二进制日志的时候，同步到磁盘上面

cp&nbsp;/data/3309/my.cnf&nbsp;/opt/backup/&nbsp;&nbsp;&nbsp;#备份配置文件<br />
mysqld_safe&nbsp;--defaults-file=/data/3309/my.cnf&nbsp;&amp;&nbsp;&nbsp;#启动mysql</pre>
</div>
<p>1、利用mysqldump完全备份mysql，配合二进制日志备份实现增量备份</p>
<p>mysqldump 选项请参考http://wangweiak47.blog.51cto.com/2337362/1589304</p>
<p>1.1提供模拟数据</p>
<div>
<pre class="prettyprint linenums">mysql -S /tmp/mysql.sock4   #连接mysql<br />
mysql&gt; use test;<br />
Database changed<br />
mysql&gt; create table test (id int(),comment char());  #创建表<br />
Query OK,  rows affected (0.34 sec)

mysql&gt; insert into test values (,'yun zhonghe');  #插入数据<br />
Query OK,  row affected (0.16 sec)</pre>
</div>
<p>1.2全量备份:</p>
<div>
<pre class="prettyprint linenums">mysqldump -S /tmp/mysql.sock4 -A -B -F -x --events --triggers --routines --master-data= &gt; /opt/backup/all_data-`date +%F--%U`.sql</pre>
</div>
<p>1.3 模拟数据发生改变</p>
<div>
<pre class="prettyprint linenums">mysql&gt; insert into test values (,'yun zhonghe2');    #再插入一条数据。<br />
Query OK,  row affected (0.11 sec)</pre>
</div>
<p>1.4 增量备份</p>
<div>
<pre class="prettyprint linenums">mysqladmin -S /tmp/mysql.sock4 flush-logs   #增量备份前，先滚动一下二进制日志。<br />
cp `cat /data//binlog/mysql-bin.index | tail -n  | head -n ` /opt/backup/   #备份二进制日志</pre>
</div>
<p>1.5 数据损坏</p>
<div>
<pre class="prettyprint linenums">rm -rf /data//<br />
killall mysqld</pre>
</div>
<p>1.6 恢复</p>
<p>上面已经提供了步骤，直接复制过来使用。</p>
<div>
<pre class="prettyprint linenums">mkdir -p /data//{data,binlog}<br />
cd /usr/local/mysql/<br />
scripts/mysql_install_db --user=mysql --datadir=/data//data/ --basedir=/usr/local/mysql/<br />
cp /opt/backup/my.cnf /data//<br />
chown mysql.mysql -R /data//<br />
mysqld_safe --defaults-file=/data//my.cnf &amp;    

mysql -S /tmp/mysql.sock4     #连接mysql查看数据<br />
mysql&gt; set sql_log_bin=;<br />
Query OK,  rows affected (0.00 sec)

mysql&gt; show variables like 'sql_log_bin';<br />
+---------------+-------+<br />
| Variable_name | Value |<br />
+---------------+-------+<br />
| sql_log_bin   | OFF   |<br />
+---------------+-------+<br />
 row in set (0.00 sec)

mysql&gt; source /opt/backup/all_data-----.sql

mysql&gt; select * from test.test;   #还缺一个数据<br />
+------+-------------+<br />
| id   | comment     |<br />
+------+-------------+<br />
|     | yun zhonghe |<br />
+------+-------------+<br />
 row in set (0.00 sec)  

mysql&gt; source /tmp/incres-.sql;

mysql&gt; select * from test.test;   #数据已恢复<br />
+------+--------------+<br />
| id   | comment      |<br />
+------+--------------+<br />
|     | yun zhonghe  |<br />
|     | yun zhonghe2 |<br />
+------+--------------+<br />
 rows in set (0.00 sec)

mysql&gt; set sql_log_bin = ;  #打开二进制记录开关。</pre>
</div>
<p>1.7小结，mysqldump适合于数据量较小的场合，它的优点是有众多选项，使用起来非常灵活，缺点是数据量一旦过大，非常耗时耗力。</p>
<p>2、使用lvm进行全备。</p>
<p>lvm快照卷原理参考</p>
<p>http://baike.baidu.com/link?url=iEpO_zm_AbHbk-ijQa8jNcFRoPPG2NdTYb_cRoQ7mjQb_ag9g-fL7yHPXV7Atp2j3J0L5xYynM9KKLIwycW_S_</p>
<p>2.1 数据接着上次继续开始。</p>
<p>2.2 全备。</p>
<p>需保证数据库存放在逻辑卷组上面，才行。</p>
<p>2.2.1首先锁表和滚动日志</p>
<div>
<pre class="prettyprint linenums">mysql&gt; flush table with read lock;<br />
Query OK,  rows affected (0.02 sec)

mysql -S /tmp/mysql.sock4 -e 'show master status;' &gt; /backup/master.info  #记录当前日志信息<br />
mysqladmin -S /tmp/mysql.sock4 flush-logs   #滚动日志</pre>
</div>
<p>2.2.2创建快照</p>
<div>
<pre class="prettyprint linenums">lvcreate -s -n snap_data -L 500M /dev/vg_node5/mylv_data<br />
  Logical volume "snap_data" created</pre>
</div>
<p>2.2.3 解锁表</p>
<div>
<pre class="prettyprint linenums">mysql&gt; unlock tables;<br />
Query OK,  rows affected (0.00 sec)</pre>
</div>
<p>2.2.4 复制快照卷数据到备份目录下</p>
<div>
<pre class="prettyprint linenums">mkdir -p /backup/lvm<br />
mount /dev/vg_node5/snap_data /mnt/lvm<br />
cp -R /mnt//* /backup/lvm</pre>
</div>
<p>2.2.5 删除快照</p>
<div>
<pre class="prettyprint linenums">umount /mnt<br />
lvremove /dev/mapper/vg_node5-snap_data<br />
Do you really want to remove active logical volume snap_data? [y/n]: y<br />
  Logical volume "snap_data" successfully removed</pre>
</div>
<p>2.3增量备份，只需和定时复制binlog到备份目录下面即可</p>
<p>2.4恢复，只需要直接拷贝备份目录下的文件即可</p>
<div>
<pre class="prettyprint linenums">killall mysqld<br />
rm -rf /data//<br />
cp -R /backup/lvm/ /data//<br />
chown mysql.mysql -R /data//<br />
mysqld_safe --defaults-file=/data//my.cnf &amp;<br />
ss -tnl | grep<br />
LISTEN                                   *:                     *:* 

mysql&gt; select * from test.test;   #数据未改变<br />
+------+--------------+<br />
| id   | comment      |<br />
+------+--------------+<br />
|     | yun zhonghe  |<br />
|     | yun zhonghe2 |<br />
+------+--------------+</pre>
</div>
<p>2.5小结：</p>
<p>lvm实现物理备份速度相对mysqldump来比较快，实现也比较简单，是不错的选择。</p>
<p>缺点：数据目录必须存放在lvm卷组上面</p>
<p>3、使用xtrabackup实现热备。</p>
<p>请自行到官网下载并安装对应的rpm包。</p>
<p>使用方法参考：详细参考：</p>
<p>http://www.cnblogs.com/Amaranthus/archive/2014/08/19/3922570.html</p>
<p>3.1创建一个具有最小权限的用户</p>
<pre class="prettyprint linenums">mkdir&nbsp;/backup/xtrabackup<br />
mysql&gt;&nbsp;grant&nbsp;RELOAD,&nbsp;LOCK&nbsp;TABLES,&nbsp;REPLICATION&nbsp;CLIENT&nbsp;on&nbsp;*.*&nbsp;to&nbsp;'bkuser'@'localhost'&nbsp;identified&nbsp;by&nbsp;'123456';<br />
mysql&gt;&nbsp;flush&nbsp;privileges;</pre>
<p>3.2完全热备。</p>
<p>使用innobakupex备份时，其会调用xtrabackup备份所有的InnoDB表，复制所有关于表结构定义的相关文件(.frm)、以及MyISAM、MERGE、CSV和ARCHIVE表的相关文件，同时还会备份触发器和数据库配置信息相关的文件。这些文件会被保存至一个以时间命令的目录中。</p>
<div>
<pre class="prettyprint linenums">innobackupex --user=bkuser --password= --socket=/tmp/mysql.sock4 --defaults-file=/data//my.cnf /backup/xtrabackup/ #相关选项自行help。<br />
#nnobackupex: completed OK! #出现此选项代表备份完成。<br />
ls /backup/xtrabackup/<br />
--01_17--</pre>
</div>
<p>(1)xtrabackup_checkpoints &mdash;&mdash; 备份类型（如完全或增量）、备份状态（如是否已经为prepared状态）和LSN(日志序列号)范围信息；</p>
<p>每个InnoDB页(通常为16k大小)都会包含一个日志序列号，即LSN。LSN是整个数据库系统的系统版本号，每个页面相关的LSN能够表明此页面最近是如何发生改变的。</p>
<p>(2)xtrabackup_binlog_info &mdash;&mdash; mysql服务器当前正在使用的二进制日志文件及至备份这一刻为止二进制日志事件的位置。</p>
<p>(3)xtrabackup_binlog_pos_innodb &mdash;&mdash; 二进制日志文件及用于InnoDB或XtraDB表的二进制日志文件的当前position。</p>
<p>(4)xtrabackup_binary &mdash;&mdash; 备份中用到的xtrabackup的可执行文件；</p>
<p>(5)backup-my.cnf &mdash;&mdash; 备份命令用到的配置选项信息；</p>
<p>3.3提供改变数据。</p>
<div>
<pre class="prettyprint linenums">mysql&gt; insert into test.test values (,'yun zhonghe3');<br />
Query OK,  row affected (0.03 sec)</pre>
</div>
<p>3.4增量备份</p>
<div>
<pre class="prettyprint linenums">innobackupex --user=bkuser --password= --socket=/tmp/mysql.sock4 --defaults-file=/data//my.cnf --incremental /backup/xtrabackup/ --incremental-basedir=/backup/xtrabackup/--01_17--/</pre>
</div>
<p>3.5 模拟数据损坏</p>
<div>
<pre class="prettyprint linenums">rm -rf /data//<br />
killall mysqld</pre>
</div>
<p>3.6增量备份恢复</p>
<div>
<pre class="prettyprint linenums">innobackupex --apply-log --redo-only /backup/xtrabackup/--01_17--/<br />
innobackupex --apply-log --redo-only /backup/xtrabackup/--01_17--/ --incremental-dir=/backup/xtrabackup/--01_17--/</pre>
</div>
<p>#注意，多实例的话，仍然需要备份配置文件，启动的时候需要binlog目录。</p>
<div>
<pre class="prettyprint linenums">mkdir -p /data//{data,binlog}<br />
chown mysql.mysql -R /data/<br />
cp /opt/backup/my.cnf /data//<br />
innobackupex --copy-back /backup/xtrabackup/--01_17--/ --defaults-file=/opt/backup/my.cnf   #恢复数据。</pre>
</div>
<p>3.6启动数据库查看。</p>
<div>
<pre class="prettyprint linenums">mysqld_safe --defaults-file=/data//my.cnf &amp;<br />
mysql -S /tmp/mysql.sock4<br />
mysql&gt; select * from test.test;   #数据修复完成。<br />
+------+--------------+<br />
| id   | comment      |<br />
+------+--------------+<br />
|     | yun zhonghe  |<br />
|     | yun zhonghe2 |<br />
|     | yun zhonghe3 |<br />
+------+--------------+<br />
 rows in set (0.01 sec)</pre>
</div>
<p>小结：</p>
<p>xtrabacup具有如下特点。</p>
<p>(1)备份过程快速、可靠；</p>
<p>(2)备份过程不会打断正在执行的事务；</p>
<p>(3)能够基于压缩等功能节约磁盘空间和流量；</p>
<p>(4)自动实现备份检验；</p>
<p>(5)还原速度快；</p>
<p>因此建议学会熟练使用xtrabackup进行备份和还原</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1prr9.html">Android如何自定义dialog</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kp7l39.html">PS特效精粹</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7gxl9.html">EBS安装过程报错，oracle&period;apps&period;fnd&period;txk&period;config&period;ProcessStateException&colon; FileSys OS COMMAND Failed &colon; Exit&equals;2 See log for details&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w34jlq.html">Codeforces Gym 100610 Problem H&period; Horrible Truth 瞎搞</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6xz3q.html">深入浅出JMS（二）&mdash;&mdash;JMS的组成</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y2oy0q.html">&lbrack;cocos2d&rsqb;场景切换以及切换进度显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmdwx09.html">PL&sol;SQL Developer 远程连接Oracle数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o1or39.html">linux中的strings命令简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjz4n49.html">SQLite语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrg4m8.html">异常信息：java&period;lang&period;OutOfMemoryError&colon; PermGen space</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkzd4e8.html">&period;net Mvc框架原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey6d5j9.html">python的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pn1oy8.html">java造成内存泄露原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/950enm68.html">Web前端-Ajax基础技术&lpar;下&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yme6r8.html">CMS使用对应版本当作新项目。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwm448.html">IIS下https配置及安全整改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj45mr9.html">elaticsear no &lbrack;query&rsqb; registered for &lbrack;filtered&rsqb; 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllrdleq.html">『MXNet』第八弹&lowbar;数据处理API&lowbar;下&lowbar;Image IO专题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m20n2rq.html">flask 开启多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4k3g1q.html">HDU 4608  I-number  2013 Multi-University Training Contest 1 1009题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zvjk59.html">Python的time（时间戳与时间字符串互相转化）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmvel8.html">【Linux 操作系统】Ubuntu 基础操作 基础命令 热键 man手册使用 关机 重启等命令使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y2jgw8.html">PHP  与搜索蜘蛛</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zvn0e9.html">PS 滤镜算法原理&mdash;&mdash;高反差保留 （High Pass）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjzwn28.html">How to download the installation package by ZOL Downer</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1mkdjq.html">和菜鸟一起学linux总线驱动之i2c死锁问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp4kgzq.html">Java继承与多态</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y27zn8.html">LeetCode&lpar;55&rpar;- Palindrome Linked List</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgrkwd8.html">angular中的jqLite的基本使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/950knn08.html">Oracle面试过程中常见的二十个问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
